import torch
from torch_geometric.transforms import SamplePoints
from torch_geometric.data import Data


def test_sample_points():
    assert SamplePoints(1024).__repr__() == 'SamplePoints(1024)'

    pos = torch.Tensor([[0, 0, 0], [1, 0, 0], [0, 1, 0], [1, 1, 0]])
    face = torch.tensor([[0, 1], [1, 2], [2, 3]])
    data = Data(pos=pos)
    data.face = face

    data = SamplePoints(8)(data)
    assert len(data) == 1
    assert pos[:, 0].min().item() >= 0 and pos[:, 0].max().item() <= 1
    assert pos[:, 1].min().item() >= 0 and pos[:, 1].max().item() <= 1
    assert pos[:, 2].abs().sum().item() == 0
